%bcond_without  fedora
%define uid 43
%define username sgeadmin
%define homedir %{_datadir}/gridengine
%define gecos Grid Engine

Name:    gridengine
Version: 6.1u3
Release: 6%{?dist}
Summary: Grid Engine - Distributed Computing Management software

Group:   Applications/System
# Only the file %{_libexecdir}/gridengine/bin/*/qmake is
# under GPLv2+, which is not used or linked by other parts
# of gridengine.
# The file %{_libexecdir}/gridengine/bin/*/qtcsh is
# under BSD with advertising, 
# which is not used or linked by other parts of gridengine.
License: (BSD and LGPLv2+ and MIT and SISSL) and GPLv2+ and BSD with advertising
URL:     http://gridengine.sunsource.net/
Source0: http://gridengine.sunsource.net/files/documents/7/161/ge-V61u3_TAG-src.tar.gz
Source1: gridengine-ppc.tar.gz
Source2: my_configuration.conf
Source3: sge.csh
Source4: sge.sh
Source5: sge_execd
Source6: sgemaster
Source7: bootstrap
Source8: Licenses
Source9: gridengine.sysconfig
Patch0: distinst.site.patch
Patch2: aimk.site.lib.patch
Patch3: gridengine-6.1u2-ppc.patch
Patch6: qtcsh.sh.h.patch
Patch7: gridengine-6.1pre-Werror.patch
Patch10: gridengine-6.1pre-depend.patch
Patch13: gridengine-6.0u8-buffer.patch
Patch14: gridengine-6.1u2-x86_64.patch
Patch15: gridengine-6.0u8-lesstif.patch
Patch16: gridengine-6.1u2-java.patch
Patch17: gridengine-6.1u3-open.patch
Patch18: gridengine-6.1u2-qmon.patch
Patch19: gridengine-6.1u2-auto.patch
Patch20: gridengine-6.1u2-qstat-xml.patch
Patch21: gridengine-6.1u3-execd.patch
Patch22: gridengine-6.1u3-rpath.patch
Patch23: gridengine-6.1u3-rctemplates.patch
Patch24: gridengine-6.1u3-perm.patch
Patch25: gridengine-6.1u3-libs.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: /bin/csh, openssl-devel, db4-devel, ncurses-devel, pam-devel
BuildRequires: lesstif-devel, libXmu-devel, libXpm-devel
BuildRequires: java-devel, ant-junit, javacc, ant-nodeps
BuildRequires: elfutils-libelf-devel, net-tools
BuildRequires: fedora-usermgmt-devel
%{?FE_USERADD_REQ}


%description
In a typical network that does not have distributed resource management
software, workstations and servers are used from 5% to 20% of the time.
Even technical servers are generally less than fully utilized. This
means that there are a lot of cycles that can be used productively if
only users know where they are, can capture them, and put them to work.

Grid Engine finds a pool of idle resources and harnesses it
productively, so an organization gets as much as five to ten times the
usable power out of systems on the network. That can increase utilization
to as much as 98%.

Grid Engine software aggregates available compute resources and
delivers compute power as a network service.

These are the local files shared by both the qmaster and execd
daemons. You must install this package in order to use any one of them.


%package devel
Summary: Gridengine development files
Group: Development/Libraries
License: BSD and LGPLv2+ and MIT and SISSL
Requires: %{name} = %{version}-%{release}

%description devel
gridengine development headers and libraries.


%package qmon
Summary: Gridengine qmon monitor
Group: Development/Libraries
License: BSD and LGPLv2+ and MIT and SISSL
Requires: %{name} = %{version}-%{release}

%description qmon
The qmon graphical grid engine monitor


%package execd
Summary: Gridengine execd program
Group: Development/Libraries
License: BSD and LGPLv2+ and MIT and SISSL
Requires: %{name} = %{version}-%{release}
Requires(post): /sbin/chkconfig
Requires(postun): /sbin/service
Requires(postun): %{name} = %{version}-%{release}
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(preun): %{name} = %{version}-%{release}

%description execd
Programs needed to run a grid engine execution host


%package qmaster
Summary: Gridengine qmaster programs
Group: Development/Libraries
License: BSD and LGPLv2+ and MIT and SISSL
Requires: %{name} = %{version}-%{release}
Requires: db4-utils
Requires(post): /sbin/chkconfig
Requires(postun): /sbin/service
Requires(postun): %{name} = %{version}-%{release}
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(preun): %{name} = %{version}-%{release}

%description qmaster
Programs needed to run a grid engine qmaster host


%prep
%setup -q -n gridengine -a 1
#Copy Licenses file into build directory
cp %SOURCE8 .
#Remove unneeded shbangs
sed -i -e '/^#! *\/bin\/sh/d' source/dist/util/install_modules/*.sh
%patch0 -p1
%patch2 -p1 -b .lib
%patch3 -p1 -b .ppc
%patch6 -p1
%patch7 -p1 -b .Werror
%patch10 -p1 -b .depend
%patch13 -p1 -b .buffer
%patch14 -p1 -b .x86_64
%patch15 -p1 -b .lesstif
%patch16 -p1 -b .java
%patch17 -p1 -b .open
%patch18 -p1 -b .qmon
%patch19 -p1 -b .auto
%patch20 -p1 -b .qstat-xml
%patch21 -p1 -b .execd
%patch22 -p1 -b .rpath
%patch23 -p1 -b .rctemplates
%patch24 -p1 -b .perm
%patch25 -p1 -b .libs
sed -i.arch -e 's,/\$DSTARCH,,g' source/scripts/distinst
#Don't ship rctemplates
rm -rf source/dist/util/rctemplates
#Don't ship windows .bat scripts
find source -name \*.bat | xargs rm
#Fix permissions
chmod +x source/dist/util/dl?.*sh 
chmod -x source/dist/util/dl.*sh 
find source -name \*.c | xargs chmod -x
#Fix flags for qmake build
find source/3rdparty/qmake source/3rdparty/qtcsh -name Makefile | 
  xargs sed -i -e "/^CFLAGS *=/s/=/= $RPM_OPT_FLAGS/"


%build
export JAVA_HOME=%{java_home}
cd source
export SGE_INPUT_CFLAGS="$RPM_OPT_FLAGS"
touch aimk
./aimk -only-depend
scripts/zerodepend
./aimk depend
./aimk
./aimk -man 


%install 
rm -rf $RPM_BUILD_ROOT

#Set the gridengine arch
gearch=`%{_builddir}/gridengine/source/dist/util/arch`
# set up the target installation directory
export SGE_ROOT=$RPM_BUILD_ROOT%{_datadir}/gridengine
mkdir -p $SGE_ROOT
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/spool/gridengine/default/qmaster
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/spool/gridengine/default/spooldb
cd source
echo 'y'| scripts/distinst -nobdb -noopenssl -local -allall -noexit ${gearch}
install -p -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/gridengine
install -p -m755 `scripts/compilearch -c ${gearch}`/qevent $RPM_BUILD_ROOT%{_datadir}/gridengine/bin

# Move things to the right location, making links back
# bin
mv $RPM_BUILD_ROOT/%{_datadir}/gridengine/bin $RPM_BUILD_ROOT/%{_prefix}
rmdir $RPM_BUILD_ROOT%{_bindir}/${gearch}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/gridengine/bin/${gearch}
# move qmake out of %{_bindir} to avoid conflicts with Qt qmake
mkdir -p $RPM_BUILD_ROOT%{_libexecdir}/gridengine/bin/${gearch}
mv $RPM_BUILD_ROOT%{_bindir}/qmake $RPM_BUILD_ROOT%{_libexecdir}/gridengine/bin/${gearch}/
ln -s ../../../../libexec/gridengine/bin/${gearch}/qmake \
      $RPM_BUILD_ROOT%{_datadir}/gridengine/bin/${gearch}/
for bin in `find $RPM_BUILD_ROOT%{_bindir} -type f -o -type l`
do
    ln -s ../../../../bin/`basename $bin` \
          $RPM_BUILD_ROOT%{_datadir}/gridengine/bin/${gearch}/
done

# utilbin
mkdir -p $RPM_BUILD_ROOT%{_libexecdir}/gridengine/utilbin
mv $RPM_BUILD_ROOT%{_datadir}/gridengine/utilbin/* \
   $RPM_BUILD_ROOT%{_libexecdir}/gridengine/utilbin
ln -s ../../../libexec/gridengine/utilbin \
      $RPM_BUILD_ROOT%{_datadir}/gridengine/utilbin/${gearch}
# We also need some db utils
ln -s ../../../bin/db_dump ../../../bin/db_load \
      $RPM_BUILD_ROOT%{_datadir}/gridengine/utilbin/

# lib
mkdir -p $RPM_BUILD_ROOT/%{_prefix}
mv $RPM_BUILD_ROOT/%{_datadir}/gridengine/lib $RPM_BUILD_ROOT/%{_libdir}

# man
mkdir -p $RPM_BUILD_ROOT/%{_mandir}
mv $RPM_BUILD_ROOT/%{_datadir}/gridengine/man/man* $RPM_BUILD_ROOT/%{_mandir}

# include
mv $RPM_BUILD_ROOT/%{_datadir}/gridengine/include $RPM_BUILD_ROOT/%{_includedir}

# app-defaults
mkdir -p $RPM_BUILD_ROOT%{_datadir}/X11/app-defaults
mv $RPM_BUILD_ROOT/%{_datadir}/gridengine/qmon/*.ad \
   $RPM_BUILD_ROOT%{_datadir}/X11/app-defaults

# The default cell directories
mkdir -p $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common

# Bootstrap file
#cp %SOURCE7 $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/

# These files get created during user setup (install_qmaster)
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/act_qmaster
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/bootstrap
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/qtask
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/settings.csh
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/settings.sh
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/sge_aliases
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/sgeexecd
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/sgemaster
touch $RPM_BUILD_ROOT%{_datadir}/gridengine/default/common/sge_request

# Environment (SGE_ROOT)
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/
install -p -m644 %SOURCE3 %SOURCE4 $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/

# Startup scripts
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
install -p -m755 %SOURCE5 %SOURCE6 $RPM_BUILD_ROOT%{_initrddir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -p -m644 %SOURCE9 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/gridengine

# Don't package catman files
rm -rf $RPM_BUILD_ROOT/%{_datadir}/gridengine/catman

# Rename some man pages to avoid conflicts
pushd $RPM_BUILD_ROOT/%{_mandir}/man5
for f in *
do
   if [ ${f:0:4} != sge_ ]
   then
      mv $f sge_$f
   fi
done
popd

#Don't need these
rm -rf $RPM_BUILD_ROOT/%{_datadir}/gridengine/3rd_party
rm -rf $RPM_BUILD_ROOT/%{_datadir}/gridengine/dtrace

#Don't ship example binaries
rm -rf $RPM_BUILD_ROOT/%{_datadir}/gridengine/examples/jobsbin
rm -rf $RPM_BUILD_ROOT/%{_datadir}/gridengine/examples/worker.*

#Cleanup some patch backups that get shipped
rm $RPM_BUILD_ROOT/%{_datadir}/gridengine/util/install_modules/inst_*.sh.*


%clean
rm -rf $RPM_BUILD_ROOT


%pre
%__fe_groupadd %uid -r %username &>/dev/null || :
%__fe_useradd  %uid -r -s /sbin/nologin -d %homedir -M          \
                    -c '%gecos' -g %username %username &>/dev/null || :

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%post execd
/sbin/chkconfig --add sge_execd

%postun execd
if [ "$1" -ge "1" ]; then
        /sbin/service sge_execd condrestart >/dev/null 2>&1 || :
fi

%preun execd
if [ $1 -eq 0 ]; then
    /sbin/service sge_execd stop
    /sbin/chkconfig --del sge_execd
fi


%post qmaster
/sbin/chkconfig --add sgemaster

%postun qmaster
if [ "$1" -ge "1" ]; then
        /sbin/service sgemaster condrestart >/dev/null 2>&1 || :
fi

%preun qmaster
if [ $1 -eq 0 ]; then
    /sbin/service sgemaster stop
    /sbin/chkconfig --del sgemaster
fi


%files
%defattr(-,root,root,-)
%doc Licenses
%config(noreplace) %{_sysconfdir}/profile.d/sge.*
%config(noreplace) %{_sysconfdir}/sysconfig/gridengine
%{_bindir}/*
%exclude %{_bindir}/qacct
%exclude %{_bindir}/qmon
%exclude %{_bindir}/sge_execd
%exclude %{_bindir}/sge_qmaster
%exclude %{_bindir}/sge_schedd
%{_libdir}/libdrmaa.so.*
%{_libdir}/libspoolb.so
%{_libdir}/libspoolc.so
%{_libdir}/jgdi.jar
%{_libdir}/juti.jar
%{_libdir}/libjgdi.so
%{_libdir}/libjuti.so
# Only the file %{_libexecdir}/gridengine/bin/*/qmake is
# under GPLv2+
# Olny the file %{_libexecdir}/gridengine/bin/*/qtcsh is
# under BSD with advertising
%{_libexecdir}/gridengine/
%attr(-,%username,%username) %dir %{_datadir}/gridengine
%{_datadir}/gridengine/bin
%exclude %{_datadir}/gridengine/bin/*/qacct
%exclude %{_datadir}/gridengine/bin/*/qmon
%exclude %{_datadir}/gridengine/bin/*/sge_execd
%exclude %{_datadir}/gridengine/bin/*/sge_qmaster
%exclude %{_datadir}/gridengine/bin/*/sge_schedd
%{_datadir}/gridengine/ckpt
%attr(-,%username,%username) %dir %{_datadir}/gridengine/default
%attr(-,%username,%username) %dir %{_datadir}/gridengine/default/common
%attr(-,%username,%username) %ghost %{_datadir}/gridengine/default/common/*
%{_datadir}/gridengine/doc
%{_datadir}/gridengine/inst_sge
%{_datadir}/gridengine/mpi
%{_datadir}/gridengine/my_configuration.conf
%dir %{_datadir}/gridengine/pvm
%{_datadir}/gridengine/pvm/*
%exclude %{_datadir}/gridengine/pvm/src
%{_datadir}/gridengine/util
%dir %{_datadir}/gridengine/utilbin
%{_datadir}/gridengine/utilbin/*
%exclude %{_datadir}/gridengine/utilbin/db_*
%{_mandir}/man1/*.1*
%exclude %{_mandir}/man1/qmon.1*
%{_mandir}/man5/*.5*
%{_mandir}/man8/*.8*
%exclude %{_mandir}/man8/sge_qmaster.8*
%exclude %{_mandir}/man8/sge_schedd.8*
%exclude %{_mandir}/man8/sge_execd.8*
%attr(-,%username,%username) %dir %{_localstatedir}/spool/gridengine
%attr(-,%username,%username) %dir %{_localstatedir}/spool/gridengine/default

%files devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/libdrmaa.so
%{_datadir}/gridengine/examples
%{_datadir}/gridengine/pvm/src
%{_mandir}/man3/*.3*

%files qmon
%defattr(-,root,root,-)
%{_bindir}/qmon
%{_libdir}/libXltree.so
%{_datadir}/X11/app-defaults/*
%{_datadir}/gridengine/bin/*/qmon
%{_datadir}/gridengine/qmon/
%{_mandir}/man1/qmon.1*

%files execd
%defattr(-,root,root,-)
%{_initrddir}/sge_execd
%{_bindir}/sge_execd
%{_datadir}/gridengine/install_execd
%{_datadir}/gridengine/bin/*/sge_execd
%{_mandir}/man8/sge_execd.8*

%files qmaster
%defattr(-,root,root,-)
%{_initrddir}/sgemaster
%{_bindir}/qacct
%{_bindir}/sge_qmaster
%{_bindir}/sge_schedd
%{_datadir}/gridengine/bin/*/qacct
%{_datadir}/gridengine/bin/*/sge_qmaster
%{_datadir}/gridengine/bin/*/sge_schedd
%{_datadir}/gridengine/install_qmaster
%{_datadir}/gridengine/utilbin/db_*
%{_mandir}/man8/sge_qmaster.8*
%{_mandir}/man8/sge_schedd.8*
%attr(-,%username,%username) %ghost %{_localstatedir}/spool/gridengine/default/qmaster
%attr(-,%username,%username) %ghost %{_localstatedir}/spool/gridengine/default/spooldb


%changelog
* Fri Feb  8 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-6
- Fixup subpackage License tags
- Service name change in scriptlets

* Thu Feb  7 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-5
- Rewrite initscripts
- Remove spurious Requires(post): /sbin/ldconfig
- Add License explanation file and fix License tags

* Mon Feb  4 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-4
- Drop arch from source
- Fix Requires() for main package
- Move man3 to -devel

* Fri Feb  1 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-3
- Fix various review comments and rpmlint issues (bug #316141)

* Thu Jan 31 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-2
- Actually ship sge_execd in the execd subpackage
- Don't complain about missing sge_execd during inst_sge -upd
- Link in db_dump and db_load into utilbin so that update scripts can find them

* Wed Jan  9 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-1
- Update to 6.1u3
- Split execd into sub-package

* Thu Nov 15 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-5
- Add BR net-tools for hostname for java build on devel

* Mon Nov 12 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-4
- Add patch and source for ppc/ppc64 builds

* Fri Nov  1 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-3
- Add patch to fix qstat xml output

* Thu Oct 18 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-2
- Cleanup arch handling
- Install qevent

* Tue Oct  2 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-1
- Fedora packaging
